	// Cdigo fuente de las pginas 255-257

	template <class T>
	class	pila;

	template <class T>
	class	nodo {
  	private:
    		T Dato;
    		nodo *Prev;
		// Constructor. Slo puede ser llamado por la clase amiga
		nodo(T i, nodo *p) { 
			Dato= i, Prev= p; 
		}

		~nodo() {}				// Destructor, no hace falta
  		friend pila<T>;
	};

	//A continuacin, la definicin de la plantilla de la clase pila de tipo T sera:

	template <class T>
	class pila {
  	private:
    		nodo<T> *TOS;			// Puntero a cabeza de pila
    		static T ERROR;
  	public:
		pila();					// Constructor
		~pila();				// Destructor
    		static
    		void	Pon_ERROR(T i){ 
			ERROR= i;
		}
    		bool	Esta_Vacia();	// Devuelve TRUE si est vaca
    		bool	Esta_Llena();	// Devuelve TRUE si est llena
    		void	Pop();			// Elimina cabeza de pila
    		void	Push(T v);		// Aade un elemento a cabeza
    		T	Top();				// Mira el elemento en cabeza
	};

	//Finalmente, la definicin de los mtodos y variables estticas para pila:
	
	template<class T>
	T pila<T>::ERROR;			// Declaramos la variable esttica

	template <class T>
	inline
	pila<T>::pila() {
  		TOS= NULL;				// Construye la pila con cabeza a NULL
	}

	template <class T>
	inline bool pila<T>::Esta_Vacia() {
  		return TOS == NULL;
	}

	template <class T>
	inline bool pila<T>::Esta_Llena() {
  		return false;			// Suponemos que siempre hay memoria
	}

	template <class T>
	void pila<T>::Pop() {		
  		if (!Esta_Vacia()) {	// Si no est vaca
			nodo<T> *Temp;	
    			Temp= TOS->Prev; 
    			delete TOS;		// Eliminamos elemento
    			TOS= Temp;			// Nueva cabeza
  		}
	}

	template <class T>
	pila<T>::~pila() {
  		while (!Esta_Vacia())	// Vaca la pila
    			Pop();
	}

	template <class T>
	void pila<T>::Push(T v) {
  		if (!Esta_Llena()) { 
			nodo<T> *Temp;
    			Temp= new nodo<T>(v, TOS);	// Llama al constructor
								// de nodo ya que somos amigos
    			TOS= Temp;
  		}
	}

	template <class T>
	T pila<T>::Top() {
  		if (!Esta_Vacia())
    			return TOS->Dato;
  		else
    			return ERROR;
	}
