//Cdigo de las pginas 474-475

class Interprete {
public:
	Interprete (unsigned NumRegistros, unsigned TamMemoria)  {
        // Inicializa variables
		Estado = noestado;
		ContadorInstrucciones = 0;
		fin = false;
		pCI = NULL;
		pCO = NULL;
		pRegistros = new Registros(NumRegistros,0);	
		pMemoria = new Memoria(TamMemoria,0);	
		pTeclado = new Teclado;
		pPantalla = new Pantalla;
	}

	~Interprete() {
		delete pPantalla;
		delete pTeclado;
		delete pRegistros;
		delete pMemoria;
		if (pCI != NULL) delete pCI;
		if (pCO != NULL) delete pCO;
	}

	// Actualiza el estado para la comparacin
	void PonerEstado(TEstado e) {
		Estado = e;
	}

    // Lee el estado para el salto
	TEstado LeerEstado() {
		return Estado;
	}

	// Cambiar el puntero de instrucciones para el salto
	void CambiarPuntero(TPosicion p) {
		ContadorInstrucciones = p;
	}

	// Fin del programa -> Parar de interpretar
	void Fin() {
		fin = true;
	}

	void CargarPrograma(TFormatoInst codigo[]);

    // Bucle de interpretacin de instrucciones
	void Interpretar();

	ContenedorOperandos *ObtenerOperandos() {
		return pCO;
	}

	// Acceso a elementos globales
	Memoria *ObtenerMemoria() {
		return pMemoria;
	}
	Registros *ObtenerRegistros() {
		return pRegistros;
	}

	Pantalla *ObtenerPantalla() {
		return pPantalla;
	}

	Teclado *ObtenerTeclado() {
		return pTeclado;
	}

private:
	Programa *pPrograma;
	ContenedorInstrucciones *pCI;
	ContenedorOperandos *pCO;
	Pantalla *pPantalla;
	Teclado *pTeclado;
	TPosicion ContadorInstrucciones;
	TEstado Estado;
	bool fin;	// Indicador de fin de programa
	// Implementamos los registros y memoria como almacn
	Registros *pRegistros;	
	Memoria *pMemoria;	

};
