//Cdigo de las pginas 475-476

class Operando {
public:
	Operando(Interprete *i) {
		pInterprete = i;
	}

	// Copia el formato del operando para poder acceder a l	
	PonFormato(TFormatoOp &f) {
		formato = f;
	};

	// Nos devuelve el valor del operando         
	virtual TValor Leer() = 0;

	// Escribe el valor del operando
	virtual void Escribir(TValor v) throw(OperacionInvalida) = 0;

    // Suma el operando op2 y escribe el resultado
	void operator += (Operando &op2);

    // Resta el operando op2 y escribe el resultado
	void operator -= (Operando &op2);

    // Compara op1 con op2
	friend TEstado Comparar (Operando &op1, Operando &op2);

protected:
 	TFormatoOp formato;
	Interprete *pInterprete;
};

void Operando::operator += (Operando &op2) {
	Escribir( Leer() + op2.Leer() );
};

void Operando::operator -= (Operando &op2) {
	Escribir( Leer() - op2.Leer() );
};

TEstado Comparar(Operando &op1, Operando &op2) {
	TValor v1 = op1.Leer(), v2 = op2.Leer();
	if (v1 > v2 )
		return mayor;
	else if (v1 < v2)
		return menor;
	else
		return igual;
};
